
import java.awt.AWTException;
import java.awt.Robot;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Scanner;
import javax.swing.Timer;


/**
 *
 * @author Coder 3.KP <fojjta.cekuj.net>
 */
public class Reading extends Thread {
    
    Socket socket;
    Scanner sc;
    
    public boolean beh = true;
    private long lp, li;
    private int poc=0;
    
    private static final int PORT=38300;
    
    private Timer t;
    
    private void initTimer() {
        t = new Timer(500, new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                System.out.println("# = "+poc);
                performNumber(poc);
                poc=0;
                t.stop();
            }
        });
    }
    
    private void performNumber(int number) {
        try {
            Robot r = new Robot();
            r.keyPress(KeyEvent.VK_ALT);
            r.keyPress(KeyEvent.VK_CONTROL);
            switch(number) {
                case 1: left(r); up(r); break;
                case 2: right(r); up(r); break;
                case 3: left(r); down(r); break;
                case 4: right(r); down(r); break;
            }
            r.keyRelease(KeyEvent.VK_ALT);
            r.keyRelease(KeyEvent.VK_CONTROL);
        } catch (AWTException ex) {
            System.out.println("performNuber: error: "+ex);
        }
    }
    
    private void left(Robot r) throws AWTException {
        r.keyPress(KeyEvent.VK_LEFT);
        r.keyRelease(KeyEvent.VK_LEFT);
    }
    
    private void right(Robot r) throws AWTException {
        r.keyPress(KeyEvent.VK_RIGHT);
        r.keyRelease(KeyEvent.VK_RIGHT);
    }
    
    private void up(Robot r) throws AWTException {
        r.keyPress(KeyEvent.VK_UP);
        r.keyRelease(KeyEvent.VK_UP);
    }
    
    private void down(Robot r) throws AWTException {
        r.keyPress(KeyEvent.VK_DOWN);
        r.keyRelease(KeyEvent.VK_DOWN);
    }
    
    private void startTime() {
        li = System.currentTimeMillis() - li;
        lp = System.currentTimeMillis();
//        System.out.println("vyp\t= "+li);
        
        t.restart(); t.stop();
    }
    
    private void stopTime() {
        lp = System.currentTimeMillis() - lp;
        li = System.currentTimeMillis();
//        System.out.println("zap\t= "+lp);
        
        poc++;
        t.start();
    }
    
    @Override
    public void run() {
        initTimer();
        //Create socket connection
        try{
            socket = new Socket("localhost", PORT);
//            out = new PrintWriter(socket.getOutputStream(), true);
            sc=new Scanner(socket.getInputStream());

            while(beh) {
                String line = sc.nextLine();
                if(line==null || line.isEmpty()) {
                    System.out.println("Device unplugged...\nclosing");
                    System.exit(0);
                }
//                System.out.println(line);
                int i = Integer.valueOf(line);
                if(i==0) startTime();   // 0 - proximity sensor covered
                else stopTime();        // 1 - uncovered
            }
            
            socket.close();
        } catch (UnknownHostException e) {
            System.err.println("Problem with socket connection (unknown host): "+e+" & "+e.getStackTrace());
        } catch (IOException e) {
            System.err.println("Cannot initiate I/O on socket: "+e+" & "+e.getStackTrace());
        }
    }
    
    
    /**
    * Initialize connection to the phone
    *
    */
    public void initializeConnection(){
    }

}
